# ab-tidy: Tidy up an address book

[Source](https://git.sr.ht/~whynothugo/ab-tidy)
| [List](https://lists.sr.ht/~whynothugo/public-inbox)

ab-tidy operates on a vdir of vcards (e.g.: a directory with vcard files
where each file contains exactly one contact). It will rename each file to
match the formatted name of the contact that it contains.

<!-- TODO: link to the vdir spec -->

This is particularly useful when the address book was created by extracting or
synchronising data from a data source where files or paths were meaningless.

For example, a directory that looks like this:

```
f0229e63-6901-4c42-a336-71b5d89649ce.vcf
78ba18ec-f101-4c7a-a481-f4bd7db2b443.vcf
dd8b5b71-812e-44c9-8de0-f2f89f259ec3.vcf
a70ed594-c99b-4a6f-b65f-852e5b1c46b6.vcf
830ecbb5-13df-4527-865e-bf3f48d130db.vcf
14e2ab6b-5b9d-443e-9808-d7135531b7d8.vcf
17f5a39c-3535-4d3a-8197-1f3e19257246.vcf
7942a4d4-1ecc-44a7-984e-fa06397ccd80.vcf
80cdc58c-d6da-494e-8ec9-5ade82baa291.vcf
bddff530-5876-4364-adf0-de49bb379473.vcf
7d1dd2bd-f24a-48f7-85ed-eea3341a07d3.vcf
b9e84b10-9193-49c0-b3f3-1bbda2a16e73.vcf
30a3da59-2649-4c40-9588-67b89cdf6a7e.vcf
c736ceb6-23b7-4b06-8647-61bce1d466db.vcf
3a528930-a224-4927-a34a-aa6f2659ee4c.vcf
f574b27e-6f75-4171-940f-b3fc2264edec.vcf
bddf79aa-c2bf-4cd2-b6c4-65d2d70a0bf4.vcf
e8d12878-46ef-46af-8f94-a82eba75ddfa.vcf
ff112694-cdeb-461c-8e8e-a75b513a99a9.vcf
```

Will be renamed into something like this:

```
Emily Johnson.vcf
Michael Brown.vcf
Sarah Wilson.vcf
Liam O'Connor.vcf
Jessica Smith.vcf
Robert Taylor.vcf
David Clark.vcf
Emma Davis.vcf
陈伟.vcf
بشير حسن.vcf
Aisha Khan.vcf
Hiroshi Tanaka.vcf
王芳 (Wang Fang).vcf
Maria Gonzalez.vcf
Priya Patel.vcf
Elena Ivanova.vcf
Ahmed Al-Sayed.vcf
Sophia Ross.vcf
Kwame Mensah.vcf
Olga Petrova.vcf
Rajesh Sharma.vcf
```

If multiple contacts have the same name, the second one will have ` (1)`
appended to it, the next one ` (2)` and so forth.

Care is taken to never overwrite files. Characters invalid in filenames are
excluded, and `..` will be replaced with `__`. Leading dots are also removed.
None of your contacts should match these rules anyway.

In case of interruption (e.g.: system power failure), a duplicate file may be
left behind. Great care is taken to ensure that data is never lost.

Running multiple copies of this program at the same time and on the same
directory may also result in duplicates. Don't do that.

Requirements
------------

Requirements:

- hare 0.24.2
- make

No runtime dependencies.

Installation
------------

Compile with `make`.

Install with `make install`.

Usage
-----

ab-tidy will operate on the current directory, unless a directory is specified
specifically as an argument.

```sh
ab-tidy # operate on the current directory
ab-tidy ~/.local/share/contacts/personal/ # operate on target directory
```

Contributing
------------

Send questions to the list. Patches welcome.

LICENCE
-------

This program is made available under the ISC licence. See LICENCE for details.
